unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Buttons, BigText;

type
  TBigWin = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    FontDialog1: TFontDialog;
    OpenDialog1: TOpenDialog;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    BigText: TBigText;
    StatusLine: TPanel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  BigWin: TBigWin;

implementation

{$R *.DFM}

procedure TBigWin.SpeedButton1Click(Sender: TObject);
var
  i, t1, t2 : longint;
  Msg: TMsg;
begin
  StatusLine.Caption := 'Inserting 10000 lines - please stand by...';
  SpeedButton1.Enabled := false;
  t1 := GetTickCount; { wait for the above messages to complete }
  repeat
    t2 := GetTickCount;
    if PeekMessage(Msg, 0, 0, 0, pm_Remove) then
    begin
      TranslateMessage(Msg);
      DispatchMessage(Msg);
    end;
  until t2 > (t1 + 100);
  for i := 0 to 10000 do
    BigText.AddLine('This is line # ' + IntToStr(i), clBlack, clWindow, false);
  BigText.RecalcRange;
  BigText.Invalidate;
  SpeedButton1.Enabled := true;
  StatusLine.Caption := '';
end;

procedure TBigWin.SpeedButton2Click(Sender: TObject);
begin
  BigText.Clear;
end;

procedure TBigWin.SpeedButton3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    BigText.LoadFromFile(OpenDialog1.FileName);
end;

procedure TBigWin.SpeedButton4Click(Sender: TObject);
begin
  if FontDialog1.Execute then
  begin
    BigText.Font := FontDialog1.Font;
    BigText.Invalidate;
  end;
end;

procedure TBigWin.SpeedButton5Click(Sender: TObject);
var
  i : longint;
begin
  for i := 0 to 9 do
    BigText.AddLine('This is line # ' + IntToStr(i), clBlack, clWindow, true);
  for i := 10 to 19 do
    BigText.AddLine('This is line # ' + IntToStr(i), clRed, clWindow, true);
  for i := 20 to 29 do
    BigText.AddLine('This is line # ' + IntToStr(i), clBlue, clWindow, true);
  for i := 30 to 39 do
    BigText.AddLine('This is line # ' + IntToStr(i), clGreen, clWindow, true);
  for i := 40 to 49 do
    BigText.AddLine('This is line # ' + IntToStr(i), clYellow, clWindow, true);
  for i := 50 to 59 do
    BigText.AddLine('This is line # ' + IntToStr(i), clWhite, clBlack, true);
  for i := 60 to 69 do
    BigText.AddLine('This is line # ' + IntToStr(i), clYellow, clRed, true);
  for i := 70 to 79 do
    BigText.AddLine('This is line # ' + IntToStr(i), clRed, clPurple, true);
  for i := 80 to 89 do
    BigText.AddLine('This is line # ' + IntToStr(i), clBlack, clAqua, true);
  for i := 90 to 99 do
    BigText.AddLine('This is line # ' + IntToStr(i), clNavy, clBlue, true);
  BigText.RecalcRange;
  BigText.Invalidate;
end;

end.
